gstreamermm: Gst::IteratorBasic< CppType > Class Template Reference

gstreamermm 1.10.0

Public Member Functions | List of all members
Gst::IteratorBasic< CppType > Class Template Reference

A class used to retrieve multiple elements in a thread safe way. More...

`#include <gstreamermm/iterator.h>`

Inheritance diagram for Gst::IteratorBasic< CppType >:
[legend]

## Public Member Functions
| IteratorBasic ()
| Default constructor. More...
| IteratorBasic (GstIterator* castitem, bool take_ownership=true)
| Creates a Gst::IteratorBasic wrapper for a GstIterator object. More...
void | begin ()
| Resynchronizes the iterator and moves the iterator to the first item. More...
CppType | operator* () const
| Dereferences the iterator and obtains the underlying object. More...
CppType* | operator-> () const
| Accesses underlying object member through the iterator. More...
IteratorBasic< CppType >& | operator++ ()
| Prefix auto-increment operator. More...
IteratorBasic< CppType > | operator++ (int)
| Postfix auto-increment operator. More...
Public Member Functions inherited from Gst::IteratorBase< CppType >
virtual IteratorResult | next ()
| Moves to the next iterator item. More...
void | resync ()
| Resynchronize the iterator. More...
bool | is_start () const
| Tells if the iterator is at the start of the list (not on the first item, but just before it). More...
bool | is_end () const
| Tells if the iterator is at the end of the list (just after the last element). More...
| operator bool () const
| Tells whether the iterator is valid and can be dereferenced. More...
GstIterator* | cobj ()
| Provides access to the underlying C GObject. More...
const GstIterator* | cobj () const
| Provides access to the underlying C GObject. More...
virtual | ~IteratorBase ()
| Frees the underlying C instance if a take_ownership value of true was used to wrap it. More...

## Additional Inherited Members
Protected Member Functions inherited from Gst::IteratorBase< CppType >
| IteratorBase ()
| Default constructor. More...
| IteratorBase (const IteratorBase< CppType >&)
| Copy constructor. More...
| IteratorBase (GstIterator* castitem, bool take_ownership=true)
| Constructs an IteratorBase from an underlying C object. More...
IteratorBase< CppType >& | operator= (const IteratorBase< CppType >& other)
| Assignment operator. More...

## Detailed Description

### template<class CppType>
class Gst::IteratorBasic< CppType >

A class used to retrieve multiple elements in a thread safe way.

Gst::IteratorBasic iterates specifically through elements that are not reference counted. Gst::Iterator is used for iterating through reference counted objects.

## Constructor & Destructor Documentation

## ◆ IteratorBasic() [1/2]

template <class CppType >

Gst::IteratorBasic< CppType >::IteratorBasic | ( |  | ) |

Default constructor.

## ◆ IteratorBasic() [2/2]

template <class CppType >

Gst::IteratorBasic< CppType >::IteratorBasic | ( | GstIterator * | castitem,
|  | bool | take_ownership = `true`
| ) |  |
| explicit

Creates a Gst::IteratorBasic wrapper for a GstIterator object.

The underlying castitem will be freed with the Gst::IteratorBasic destruction if a take_ownership value of true is given.

Parameters

  castitem | The C instance to wrap.
  take_ownership | Whether to take over the underlying C object. If true, C object is freed when wrapper is destroyed.

## Member Function Documentation

## ◆ begin()

template <class CppType >

void Gst::IteratorBasic< CppType >::begin | ( |  | ) |

Resynchronizes the iterator and moves the iterator to the first item.

Exceptions

  std::runtime_error | (if a Gst::ITERATOR_ERROR is encountered or if a concurrent update to the iterator occurs while it is advanced to the first element).

## ◆ operator*()

template <class CppType >

CppType Gst::IteratorBasic< CppType >::operator* | ( |  | ) | const

Dereferences the iterator and obtains the underlying object.

## ◆ operator++() [1/2]

template <class CppType >

IteratorBasic<CppType>& Gst::IteratorBasic< CppType >::operator++ | ( |  | ) |

Prefix auto-increment operator.

It advances to the next item in the iterator. It is faster than the postfix operator.

Exceptions

  std::runtime_error | (if a Gst::ITERATOR_ERROR is encountered or if a concurrent update to the iterator occurs while it iterates).

## ◆ operator++() [2/2]

template <class CppType >

IteratorBasic<CppType> Gst::IteratorBasic< CppType >::operator++ | ( | int |  | ) |

Postfix auto-increment operator.

It advances to the next item in the iterator.

Exceptions

  std::runtime_error | (if a Gst::ITERATOR_ERROR is encountered or if a concurrent update to the iterator occurs while it iterates).

## ◆ operator->()

template <class CppType >

CppType* Gst::IteratorBasic< CppType >::operator-> | ( |  | ) | const

Accesses underlying object member through the iterator.